searchNodes=[{"doc":"NervesUEvent listens for events from the Linux kernel, automatically loads device drivers, and forwards them to your Elixir programs. NervesUEvent is a very simple version of the Linux udevd . Just like udevd does for desktop Linux, NervesUEvent registers to receive UEvents from the Linux kernel. Unlike udevd , NervesUEvent only runs modprobe when needed and keeps track of what hardware is in the system. For most Nerves use cases, udevd isn't needed.","ref":"NervesUEvent.html","title":"NervesUEvent","type":"module"},{"doc":"Get the most recent value of UEvent report For example, &gt; NervesUEvent . get ( [ &quot;devices&quot; , &quot;platform&quot; , &quot;leds&quot; , &quot;leds&quot; , &quot;red:indicator-1&quot; ] ) %{ &quot;of_compatible_n&quot; =&gt; &quot;0&quot; , &quot;of_fullname&quot; =&gt; &quot;/leds/rgb1-blue&quot; , &quot;of_name&quot; =&gt; &quot;rgb1-blue&quot; , &quot;subsystem&quot; =&gt; &quot;leds&quot; } }","ref":"NervesUEvent.html#get/2","title":"NervesUEvent.get/2","type":"function"},{"doc":"Get all reported UEvents","ref":"NervesUEvent.html#get_all/0","title":"NervesUEvent.get_all/0","type":"function"},{"doc":"Run an arbitrary match against UEvents Use :_ in the path to accept any value in that position Use :&quot;$&quot; at the end of the path to perform an exact match","ref":"NervesUEvent.html#match/1","title":"NervesUEvent.match/1","type":"function"},{"doc":"Subscribe to uevent notifications Pass a pattern like one you'd pass to match/1 . Instead of getting a response, you'll receive a message when a matching UEvent happens.","ref":"NervesUEvent.html#subscribe/1","title":"NervesUEvent.subscribe/1","type":"function"},{"doc":"GenServer that captures Linux uevent messages and passes them up to Elixir.","ref":"NervesUEvent.UEvent.html","title":"NervesUEvent.UEvent","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"NervesUEvent.UEvent.html#child_spec/1","title":"NervesUEvent.UEvent.child_spec/1","type":"function"},{"doc":"","ref":"NervesUEvent.UEvent.html#start_link/1","title":"NervesUEvent.UEvent.start_link/1","type":"function"},{"doc":"","ref":"NervesUEvent.UEvent.html#t:option/0","title":"NervesUEvent.UEvent.option/0","type":"type"},{"doc":"NervesUEvent listens for events from the Linux kernel, automatically loads device drivers, and forwards them to your Elixir programs. NervesUEvent is a very simple version of the Linux udevd . Just like udevd does for desktop Linux, NervesUEvent registers to receive UEvents from the Linux kernel. Unlike udevd , NervesUEvent only runs modprobe when needed and keeps track of what hardware is in the system. For most Nerves use cases, udevd isn't needed. Warning Almost all Nerves systems require some kernel modules to be automatically loaded or critical functionality won't work. WiFi device drivers, for example, are almost always kernel modules. If you're not using NervesUEvent or udevd or some other library that automatically loads kernel modules, you'll need to add calls to modprobe to your application. Nerves projects generally depend on either :nerves_uevent or a version of :nerves_runtime that included similar functionality. It's an advanced use case to modify this dependency.","ref":"readme.html","title":"NervesUEvent","type":"extras"},{"doc":"NervesUEvent automatically starts on boot. Configuration is supplied via application config. The following option is available: :autoload_modules - defaults to true to automatically run modprobe when needed Here's a config.exs example: config :nerves_uevent , autoload_modules : false","ref":"readme.html#configuration","title":"NervesUEvent - Configuration","type":"extras"},{"doc":"NervesUEvent is currently very low level in what it reports and reflects the Linux representation. For example, say that you're interested in an MMC device and you've found out that Linux exposes it in the /sys/devices/platform/soc/2100000.bus/2194000.mmc directory. Linux also sends UEvent messages for all devices in /sys/device , so NervesUEvent will know about this too. To query NervesUEvent for device information, drop /sys off the path and convert to a list of strings like this: iex&gt; NervesUEvent . get ( [ &quot;devices&quot; , &quot;platform&quot; , &quot;soc&quot; , &quot;2100000.bus&quot; , &quot;2190000.mmc&quot; ] ) %{ &quot;driver&quot; =&gt; &quot;sdhci-esdhc-imx&quot; , &quot;modalias&quot; =&gt; &quot;of:NmmcT(null)Cfsl,imx6ull-usdhcCfsl,imx6sx-usdhc&quot; , &quot;of_alias_0&quot; =&gt; &quot;mmc1&quot; , &quot;of_compatible_0&quot; =&gt; &quot;fsl,imx6ull-usdhc&quot; , &quot;of_compatible_1&quot; =&gt; &quot;fsl,imx6sx-usdhc&quot; , &quot;of_compatible_n&quot; =&gt; &quot;2&quot; , &quot;of_fullname&quot; =&gt; &quot;/soc/bus@2100000/mmc@2190000&quot; , &quot;of_name&quot; =&gt; &quot;mmc&quot; , &quot;subsystem&quot; =&gt; &quot;platform&quot; } Some devices have more useful information than others. This particular one mostly shows information found in the device tree file for this device. Of note is the &quot;modalias&quot; key. When NervesUEvent sees this, it will try to load the appropriate Linux kernel driver for this device if one exists. More usefully, you can subscribe for events. For example, if you'd like to be notified when a MicroSD card has been inserted, you can subscribe to all events on that device: iex&gt; NervesUEvent . subscribe ( [ &quot;devices&quot; , &quot;platform&quot; , &quot;soc&quot; , &quot;2100000.bus&quot; , &quot;2190000.mmc&quot; ] ) If you're not sure what to subscribe to, subscribe to all events to see what happens: iex&gt; NervesUEvent . subscribe ( [ ] ) Now if you physically insert a MicroSD card, NervesUEvent will send messages to your process mailbox. Here's one of the events: iex&gt; flush % PropertyTable.Event { table : NervesUEvent , timestamp : 2558213871126 , property : [ &quot;devices&quot; , &quot;platform&quot; , &quot;soc&quot; , &quot;2100000.bus&quot; , &quot;2190000.mmc&quot; , &quot;mmc_host&quot; , &quot;mmc0&quot; , &quot;mmc0:1234&quot; ] , value : %{ &quot;mmc_name&quot; =&gt; &quot;SA04G&quot; , &quot;mmc_type&quot; =&gt; &quot;SD&quot; , &quot;modalias&quot; =&gt; &quot;mmc:block&quot; , &quot;subsystem&quot; =&gt; &quot;mmc&quot; } , previous_timestamp : nil , previous_value : nil } The primary fields of interest are :table , :timestamp , :property , and :value . NervesUEvent uses the PropertyTable library for storing everything and publishing changes. The timestamps are from System.monotonic_time/0 .","ref":"readme.html#usage","title":"NervesUEvent - Usage","type":"extras"},{"doc":"Copyright (C) 2017-22 Nerves Project Authors Licensed under the Apache License , Version 2.0 ( the &quot;License&quot; ) ; you may not use this file except in compliance with the License . You may obtain a copy of the License at [ http :// www . apache . org / licenses / LICENSE - 2.0 ] ( http :// www . apache . org / licenses / LICENSE - 2.0 ) Unless required by applicable law or agreed to in writing , software distributed under the License is distributed on an &quot;AS IS&quot; BASIS , WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND , either express or implied . See the License for the specific language governing permissions and limitations under the License .","ref":"readme.html#license","title":"NervesUEvent - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Extract UEvent code from Nerves.Runtime and update to use the PropertyTable library.","ref":"changelog.html#v0-1-0-2022-04-26","title":"Changelog - v0.1.0 - 2022-04-26","type":"extras"}]